{..............................................

CopyRight (c) 1997 Objects Built for you! (O.B.you!)

MODULO: SysInfoClass.pas

Data: 09/4/97 (mm/dd/yy)

NOTE: Modulo per informazioni sul sistema.


HISTORY:
  version 1.0

..............................................}

unit SysInfoClass;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
  
type
  TSysInfo = class//(TComponent)
  private
    FMemStat    :TMemoryStatus;
    FSysInfo    :TSystemInfo;
    FOsVerInfo  :TOsVersionInfo;
    FBuildNumber:word;
  protected
    procedure getMemoryStatus;
    procedure getSysInfo;
    procedure getOsVerInfo;
    function  getszCSDVersion:string;
  public
    //constructor Create(AOwner :TComponent);override;
    constructor CreateMemStatus;
    constructor CreateSysInfo;
    constructor CreateOsVerInfo;
    destructor  Destroy;override;
  published
    // propriet MemoryStatus
    property MemoryLoad:DWORD read FMemStat.dwMemoryLoad;
    property TotalPhys:DWORD read FMemStat.dwTotalPhys;
    property AvailPhys:DWORD read FMemStat.dwAvailPhys;
    property TotalPageFile:DWORD read FMemStat.dwTotalPageFile;
    property AvailPageFile:DWORD read FMemStat.dwAvailPageFile;
    property TotalVirtual:DWORD read FMemStat.dwTotalVirtual;
    property AvailVirtual:DWORD read FMemStat.dwAvailVirtual;
    // propriet Systeminfo
    property ProcessorArchitecture: Word read FSysInfo.wProcessorArchitecture;
    property PageSize: DWORD read FSysInfo.dwPageSize;
    property MinimumApplicationAddress: Pointer read FSysInfo.lpMinimumApplicationAddress;
    property MaximumApplicationAddress: Pointer read FSysInfo.lpMaximumApplicationAddress;
    property ActiveProcessorMask: DWORD read FSysInfo.dwActiveProcessorMask;
    property NumberOfProcessors: DWORD read FSysInfo.dwNumberOfProcessors;
    property ProcessorType: DWORD read FSysInfo.dwProcessorType;
    property AllocationGranularity: DWORD read FSysInfo.dwAllocationGranularity;
    property ProcessorLevel: Word read FSysInfo.wProcessorLevel;
    property ProcessorRevision: Word read FSysInfo.wProcessorRevision;
    // propriet OSVersionInfo
    property MajorVersion: DWORD read FOsVerInfo.dwMajorVersion;
    property MinorVersion: DWORD read FOsVerInfo.dwMinorVersion;
    property BuildNumber: WORD read FBuildNumber;
    property PlatformId: DWORD read FOsVerInfo.dwPlatformId;
    property CSDVersion: string read getszCSDVersion;
  end;

//procedure Register;

implementation

{Constructor TSysInfo.Create(AOwner :TComponent);
begin
  inherited Create(AOwner);
  getMemoryStatus;
end;}

Constructor TSysInfo.CreateMemStatus;
begin
  inherited Create;
  getMemoryStatus;
end;

Constructor TSysInfo.CreateSysInfo;
begin
  inherited Create;
  getSysInfo;
end;

Constructor TSysInfo.CreateOsVerInfo;
begin
  inherited Create;
  getOsVerInfo;
end;

destructor TSysInfo.Destroy;
begin
  inherited Destroy;
end;

procedure TSysInfo.getMemoryStatus;
begin
  ZeroMemory(@FMemStat,SizeOf(FMemStat));
  FMemStat.dwLength:=SizeOf(FMemStat);
  GlobalMemoryStatus(FMemStat);
end;

procedure TSysInfo.getSysInfo;
begin
  ZeroMemory(@FSysInfo,SizeOf(FSysInfo));
  GetSystemInfo(FSysInfo);
end;

procedure TSysInfo.getOsVerInfo;
begin
  ZeroMemory(@FOsVerInfo,SizeOf(FOsVerInfo));
  FOsVerInfo.dwOSVersionInfoSize:=SizeOf(FOsVerInfo);
  GetVersionEx(FOsVerInfo);
  FBuildNumber:=word(FOsVerInfo.dwBuildNumber);
end;

function TSysInfo.getszCSDVersion:string;
begin
  Result:=FOsVerInfo.szCSDVersion;
end;
//Registrazione componente.
//procedure Register;
//begin
//  RegisterComponents('Samples', [TSysInfo]);
//end;

end.
