{..............................................

CopyRight (c) 1997 Objects Built for you! (O.B.you!)

MODULO: SysInfoComp.pas

Data: 09/4/97 (mm/dd/yy)

NOTE: Modulo per informazioni sul sistema.


HISTORY:
  version 1.0

..............................................}

unit SysInfoComp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

const
  //define from winnt.h
  PROCESSOR_INTEL_386     =386;
  PROCESSOR_INTEL_486     =486;
  PROCESSOR_INTEL_PENTIUM =586;
  PROCESSOR_MIPS_R4000    =4000;
  PROCESSOR_ALPHA_21064   =21064;

  PROCESSOR_ARCHITECTURE_INTEL =0;
  PROCESSOR_ARCHITECTURE_MIPS  =1;
  PROCESSOR_ARCHITECTURE_ALPHA =2;
  PROCESSOR_ARCHITECTURE_PPC   =3;
  PROCESSOR_ARCHITECTURE_UNKNOWN =$FFFF;

  PF_FLOATING_POINT_PRECISION_ERRATA  =0;   
  PF_FLOATING_POINT_EMULATED          =1;   
  PF_COMPARE_EXCHANGE_DOUBLE          =2;   
  PF_MMX_INSTRUCTIONS_AVAILABLE       =3;
  
type
  TSysInfoComp = class(TComponent)
  private
    FMemStat    :TMemoryStatus;
    FSysInfo    :TSystemInfo;
    FOsVerInfo  :TOsVersionInfo;
    // propriet MemoryStatus
    FMemoryLoad:DWORD;
    FTotalPhys:DWORD;
    FAvailPhys:DWORD;
    FTotalPageFile:DWORD;
    FAvailPageFile:DWORD;
    FTotalVirtual:DWORD;
    FAvailVirtual:DWORD;
    // propriet Systeminfo
    FProcessorArchitecture: Word;
    FPageSize: DWORD;
    FMinimumApplicationAddress: Pointer;
    FMaximumApplicationAddress: Pointer;
    FActiveProcessorMask: DWORD;
    FNumberOfProcessors: DWORD;
    FProcessorType: DWORD;
    FAllocationGranularity: DWORD;
    FProcessorLevel: Word;
    FProcessorRevision: Word;
    // propriet OSVersionInfo
    FMajorVersion: DWORD;
    FMinorVersion: DWORD;
    FBuildNumber:word;
    FPlatformId: DWORD;
    FCSDVersion: string;
  protected
    function  getMinAppAddress:DWORD;
    function  getMaxAppAddress:DWORD;
    procedure DummyDWord(value :DWORD);
    procedure DummyWord(value :WORD);
    procedure DummyString(value :string);
  public
    constructor Create(AOwner :TComponent);override;
    //destructor  Destroy;override;
  published
    // propriet MemoryStatus
    property msMemoryLoad:DWORD read FMemoryLoad write DummyDWord;
    property msTotalPhys:DWORD read FTotalPhys write DummyDWord;
    property msAvailPhys:DWORD read FAvailPhys write DummyDWord;
    property msTotalPageFile:DWORD read FTotalPageFile write DummyDWord;
    property msAvailPageFile:DWORD read FAvailPageFile write DummyDWord;
    property msTotalVirtual:DWORD read FTotalVirtual write DummyDWord;
    property msAvailVirtual:DWORD read FAvailVirtual write DummyDWord;
    // propriet Systeminfo
    property siProcessorArchitecture: Word read FProcessorArchitecture write DummyWord;
    property siPageSize: DWORD read FPageSize write DummyDWord;
    property siMinimumApplicationAddress: DWORD read getMinAppAddress write DummyDWord;
    property siMaximumApplicationAddress: DWORD read getMaxAppAddress write DummyDWord;
    property siActiveProcessorMask: DWORD read FActiveProcessorMask write DummyDWord;
    property siNumberOfProcessors: DWORD read FNumberOfProcessors write DummyDWord;
    property siProcessorType: DWORD read FProcessorType write DummyDWord;
    property siAllocationGranularity: DWORD read FAllocationGranularity write DummyDWord;
    property siProcessorLevel: Word read FProcessorLevel write DummyWord;
    property siProcessorRevision: Word read FProcessorRevision write DummyWord;
    // propriet OSVersionInfo
    property osMajorVersion: DWORD read FMajorVersion write DummyDWord;
    property osMinorVersion: DWORD read FMinorVersion write DummyDWord;
    property osBuildNumber: WORD read FBuildNumber write DummyWord;
    property osPlatformId: DWORD read FPlatformId write DummyDWord;
    property osCSDVersion: string read FCSDVersion write DummyString;
  end;

procedure Register;

implementation

Constructor TSysInfoComp.Create(AOwner :TComponent);
begin
  inherited Create(AOwner);
  ZeroMemory(@FMemStat,SizeOf(FMemStat));
  FMemStat.dwLength:=SizeOf(FMemStat);
  GlobalMemoryStatus(FMemStat);
  ZeroMemory(@FSysInfo,SizeOf(FSysInfo));
  GetSystemInfo(FSysInfo);
  ZeroMemory(@FOsVerInfo,SizeOf(FOsVerInfo));
  FOsVerInfo.dwOSVersionInfoSize:=SizeOf(FOsVerInfo);
  GetVersionEx(FOsVerInfo);
   // propriet MemoryStatus
  FMemoryLoad := FMemStat.dwMemoryLoad;
  FTotalPhys := FMemStat.dwTotalPhys;
  FAvailPhys := FMemStat.dwAvailPhys;
  FTotalPageFile := FMemStat.dwTotalPageFile;
  FAvailPageFile := FMemStat.dwAvailPageFile;
  FTotalVirtual := FMemStat.dwTotalVirtual;
  FAvailVirtual := FMemStat.dwAvailVirtual;
    // propriet Systeminfo
  FProcessorArchitecture := FSysInfo.wProcessorArchitecture;
  FPageSize := FSysInfo.dwPageSize;
  FMinimumApplicationAddress := FSysInfo.lpMinimumApplicationAddress;
  FMaximumApplicationAddress := FSysInfo.lpMaximumApplicationAddress;
  FActiveProcessorMask := FSysInfo.dwActiveProcessorMask;
  FNumberOfProcessors := FSysInfo.dwNumberOfProcessors;
  FProcessorType := FSysInfo.dwProcessorType;
  FAllocationGranularity := FSysInfo.dwAllocationGranularity;
  FProcessorLevel := FSysInfo.wProcessorLevel;
  FProcessorRevision := FSysInfo.wProcessorRevision;
    // propriet OSVersionInfo
  FMajorVersion := FOsVerInfo.dwMajorVersion;
  FMinorVersion := FOsVerInfo.dwMinorVersion;
  FBuildNumber := word(FOsVerInfo.dwBuildNumber);
  FPlatformId := FOsVerInfo.dwPlatformId;
  FCSDVersion := FOsVerInfo.szCSDVersion;
end;

{destructor TSysInfo.Destroy;
begin
  inherited Destroy;
end;}

function  TSysInfoComp.getMinAppAddress:DWORD;
begin
  Result:=DWORD(FMinimumApplicationAddress);
end;

function  TSysInfoComp.getMaxAppAddress:DWORD;
begin
  Result:=DWORD(FMaximumApplicationAddress);
end;

procedure TSysInfoComp.DummyDWord(value :DWORD);
begin
// routine finta
end;

procedure TSysInfoComp.DummyWord(value :WORD);
begin
// routine finta
end;

procedure TSysInfoComp.DummyString(value :string);
begin
// routine finta
end;

//Registrazione componente.
procedure Register;
begin
  RegisterComponents('System', [TSysInfoComp]);
end;

end.
