unit Test;

(*

 This version has been tested with Delphi 2.0 and seems to work fine.
 This does NOT work with 16-bit Delphi! The 16-bit version is in a file
 called inmemory.zip.

  This is an exmple of how to use TInMemoryTable and TTempTable.
  See inmem.pas and temptbl.pas for more information.

  WARNING! THIS CODE IS PROVIDED AS IS WITH NO GUARANTEES OF ANY KIND!
  USE THIS AT YOUR OWN RISK - YOU ARE THE ONLY PERSON RESPONSIBLE FOR
  ANY DAMAGE THIS CODE MAY CAUSE - YOU HAVE BEEN WARNED!

  Have Fun!

  Gregory Trubetskoy <grisha@mira.com>
  http://www.mira.com/home/grisha

*)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, InMem, TempTbl,StdCtrls, DBTables, Grids, DBGrids, DB,
  ExtCtrls, Outline, DirOutln, FileCtrl, ShellAPI;

type
  TTestForm = class(TForm)
    InMemoryButton: TButton;
    InMemoryDataSource: TDataSource;
    DBGrid1: TDBGrid;
    Bevel1: TBevel;
    Bevel2: TBevel;
    TempButton: TButton;
    DBGrid2: TDBGrid;
    TempDataSource: TDataSource;
    TableNameLabel: TLabel;
    IndexButton: TButton;
    Bevel3: TBevel;
    Label1: TLabel;
    procedure InMemoryButtonClick(Sender: TObject);
    procedure TempButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IndexButtonClick(Sender: TObject);
    procedure Label1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    MyInMemoryTable: TInMemoryTable;
    MyTempTable: TTempTable;
  end;

var
  TestForm: TTestForm;

implementation

{$R *.DFM}

procedure TTestForm.InMemoryButtonClick(Sender: TObject);
begin

  MyInMemoryTable := TInMemoryTable.Create(TestForm);
  with MyInMemoryTable do begin
    DatabaseName := 'DBDEMOS';
    { TableName can be anything - but cannot be blank or DBE will give you
      an invalid parameter error }
    TableName := 'xxx.db';
    { add a couple of fields }
    FieldDefs.Add('Field1', ftString, 10, False);
    FieldDefs.Add('Field2', ftString, 15, False);
    CreateTable;
    { open the table }
    Active := True;
    { add a couple of records }
    InsertRecord(['This table', 'is in memory!']);
    InsertRecord(['Check it', 'out!']);
    { link the grid on the form to this table }
    InMemoryDataSource.DataSet := MyInMemoryTable;
  end;

end;

procedure TTestForm.TempButtonClick(Sender: TObject);
begin
  MyTempTable := TTempTable.Create(TestForm);
  with MyTempTable do begin
    DatabaseName := Session.PrivateDir;
    { TableName can be anything - but cannot be blank or DBE will give you
      an invalid parameter error }
    TableName := 'tmp.db';
    { add a couple of fields }
    FieldDefs.Add('Field1', ftString, 10, False);
    FieldDefs.Add('Field2', ftString, 15, False);
    CreateTable;
    { open the table }
    Active := True;
    { add a primary index }
    AddIndex('','Field1', [ixPrimary]);
    AddIndex('Field2', 'Field2', []);
    { add a couple of records }
    InsertRecord(['c', 'It has an index.']);
    InsertRecord(['a', 'This table']);
    InsertRecord(['b', 'is temporary.']);
    InsertRecord(['d', 'Check it out!']);
    { link the grid on the form to this table }
    TempDataSource.DataSet := MyTempTable;
    { teble name }
    TableNameLabel.Caption := 'Table Name: ' + MyTempTable.TableName;
    IndexButton.Enabled := True;
  end;
end;

procedure TTestForm.FormCreate(Sender: TObject);
var
  TempDir: array[0..255] of Char;
begin
  { Set private directory }
  GetEnvironmentVariable('TMP', TempDir, 255);
  Session.PrivateDir := TempDir;
end;

procedure TTestForm.IndexButtonClick(Sender: TObject);
begin
  with MyTempTable do begin
    if IndexName <> 'Field2' then
      IndexName := 'Field2'
    else
      IndexName := '';
  end;
end;

procedure TTestForm.Label1DblClick(Sender: TObject);
var
  URLFile: TStringList;
  URLFileName: array[0..255] of Char;
begin
  URLFile := TStringList.Create;
  URLFile.Add('[InternetShortcut]');
  URLFile.Add('URL=http://www.mira.com/home/grisha');
  GetEnvironmentVariable('TMP', URLFileName, 255);
  StrLCat(URLFileName, '\Grisha''s Home Page.url', SizeOf(URLFileName));
  URLFile.SaveToFile(URLFileName);
  ShellExecute( Application.MainForm.Handle, pChar('open'), URLFileName, nil, nil, 0);
end;

end.
